import os
import shutil
import re
import time
from   time       import time
from   time       import gmtime, strftime
from   time       import sleep
import pydim
import threading
import sys

class UpdateHelper:
    def __init__(self, _alignConf):
        self.alignConf = _alignConf
        self.nameStr = self.alignConf.getProp('nameStr')
        self.tiltNames = self.alignConf.getProp('tiltNames')
        self.workdir = self.alignConf.getProp('WorkDir')
        self.whichRich = self.alignConf.getProp('Rich')
        self.magnFactorsMode = self.alignConf.getProp('magnFactorsMode')
        self.magnifDir = self.alignConf.getProp('magnifDir') 
        self.serviceName = "/Publisher/Rich"+str(self.whichRich)+"/MirrorAlign"
        self.format = "C" # "C" means a string
        self.updateString = ""
        self.serverName = "Rich"+str(self.whichRich)+"MirrorAlign_0" 
        self.svc = None        

    def startUpdateDIM(self):
        self.svc = pydim.dis_add_service(self.serviceName, self.format, self.updateStringTuple, 1)
        if not self.svc:
            sys.stderr.write("An error occurred while registering the "+ self.serviceName +" DB update DIM service\n")
            sys.exit(1)
        pydim.dis_start_serving(self.serverName) 
        print 'INFO: Started DB update DIM service ' + self.serviceName + ' with server ' + self.serverName

        print 'INFO: Sending initialization update code (i.e. just a dummy empty string to start): ', self.updateStringTuple('')
        sys.stdout.flush()
        pydim.dis_update_service(self.svc)
        
    def stopUpdateDIM(self):
        if self.svc:
            pydim.dis_remove_service(self.svc)

    def updateDecision(self, n_it): 
        decision = False
        if n_it >= 1:
            decision = True
        return decision

    #  the callback function must return a tuple
    def updateStringTuple(self, tag):
        stringTuple = self.updateString
        return (stringTuple, )

    def updateDB(self, N_DB, decision): 
        import OnlineEnv as Online
        runs = Online.DeferredRuns
        minRun = sys.maxint 
        for i in range(0, len(runs)):
            if int(runs[i]) < int(minRun):
                minRun = int(runs[i])
        self.updateString = str(minRun)+" v"+str(N_DB)
        if not self.svc:
            sys.stderr.write("The "+ self.serviceName +" DB update DIM service does not exist\n")
            sys.exit(1)
        if decision:
            print 'INFO: Sending the following update code to the ' + self.serviceName + ' DB update DIM service'
            print 'INFO: This should trigger an automatic update of the DB: '
        else:
            print 'INFO: Sending the following update code to the ' + self.serviceName + ' DB update DIM service'
            print 'INFO: This will not update the DB (the alignment was fine, or autoUpdate is False): '
        print self.updateStringTuple('')
        pydim.dis_update_service(self.svc)
        print 'INFO: We now wait 20 seconds for Online to pick up our update.'
        sys.stdout.flush()
        sleep(20) # to give time for the update to be caught
