class tiltObj:
    def __init__(self, _alignConf):
        self.alignConf = _alignConf
        self.whichRich = self.alignConf.getProp('Rich')
        import re
        if self.whichRich == 1:
            self.priRe = re.compile('SphMirror[0-3]_Align')
            self.secRe = re.compile('SecMirror([0-9]|1[0-5])_Align')
        else:
            self.priRe = re.compile('Rich2SphMirror[0-9]*_Align')
            self.secRe = re.compile('Rich2SecMirror[0-9]*_Align')
            
        self.priY = {}
        self.priZ = {}
        self.secY = {}
        self.secZ = {}
        if(self.whichRich == 1):
            self.maxpri = 3
            self.maxsec = 15
        if(self.whichRich == 2):
            self.maxpri = 55
            self.maxsec = 39
            
        for i in range(0, self.maxpri + 1):
            self.priY[i] = []
            self.priZ[i] = []
        for i in range(0, self.maxsec + 1):
            self.secY[i] = []
            self.secZ[i] = []

    def writeChange(self,n):
        import os
        filename = self.alignConf.getProp('WorkDir') + 'Rich' + str(self.whichRich) + '_ChangeWRTDB_' + str(n) + '.txt'
        if os.path.exists(filename):
            os.remove(filename)
        f = open(filename, 'w')
        args = 'Primary mirrors \n'
        for i in range(0, self.maxpri + 1):
            args += str(i) + '    ' + str(self.priY[i]) + '     ' + str(self.priZ[i]) + '\n'
        args += '\n'
        args += 'Secondary mirrors \n'
        for i in range(0, self.maxsec + 1):
            args += str(i) + '    ' + str(self.secY[i])+ '     ' + str(self.secZ[i]) + '\n'
        f.write(args)
        f.close()

    def setChange(self, files):
        from   lxml         import etree
        
        print "INFO: compareXML ", files[0]
        print "INFO: self.lastXMLFile ", files[1]
        parser = etree.XMLParser(remove_blank_text=True)
        
        tree0 = etree.parse(files[0], parser)
        treeN = etree.parse(files[1], parser)
        
        tilts0 = self.xmlToDict(tree0)
        tiltsN = self.xmlToDict(treeN)
        
        for i in range(0, self.maxpri + 1):
            self.priY[i] = tilts0[0][i] - tiltsN[0][i]
            self.priZ[i] = tilts0[1][i] - tiltsN[1][i]
        
        for i in range(0, self.maxsec + 1):
            self.secY[i] = tilts0[2][i] - tiltsN[2][i]
            self.secZ[i] = tilts0[3][i] - tiltsN[3][i]
    
    def getGraphs(self):
        from   ROOT         import TGraph, TMultiGraph

        graph_priY = TGraph(self.maxpri)
        graph_priZ = TGraph(self.maxpri)
        graph_secY = TGraph(self.maxsec)
        graph_secZ = TGraph(self.maxsec)
        
        for i in range(0, self.maxpri + 1):
            graph_priY.SetPoint(i, i, self.priY[i])
            graph_priZ.SetPoint(i, i, self.priZ[i])
        for i in range(0, self.maxsec +1):
            graph_secY.SetPoint(i, i, self.secY[i])
            graph_secZ.SetPoint(i, i, self.secZ[i])

        graph_priY.SetMarkerStyle(8)
        graph_priY.SetMarkerColor(2) #red
        graph_priZ.SetMarkerStyle(8)
        graph_priZ.SetMarkerColor(4) #blue
        graph_secY.SetMarkerStyle(8)
        graph_secY.SetMarkerColor(2)
        graph_secZ.SetMarkerStyle(8)
        graph_secZ.SetMarkerColor(4)
        
        mg1 = TMultiGraph()
        mg1.Add(graph_priY)
        mg1.Add(graph_priZ)
        mg2 = TMultiGraph()
        mg2.Add(graph_secY)
        mg2.Add(graph_secZ)
        
        return [mg1, mg2]
        
    def xmlToDict(self, tree):
        priTiltY = {}
        priTiltZ = {}
        secTiltY = {}
        secTiltZ = {}
        root = tree.getroot()
        for cond in root.findall('condition'):
            if self.priRe.match(cond.attrib['name']):
                for paramV in cond.findall('paramVector'):
                    if paramV.attrib['name'] == 'dRotXYZ':
                        dRotXYZ = paramV.text.strip('*mrad').split('*mrad')
                        if self.whichRich == 2:
                            mirrNumber = cond.attrib['name'].replace('Rich2', '')
                        else:
                            mirrNumber = cond.attrib['name']
                        mirrNumber = mirrNumber.strip('SphMirror_Align')
                        priTiltY[int(float(mirrNumber))] = float(dRotXYZ[1])
                        priTiltZ[int(float(mirrNumber))] = float(dRotXYZ[2])
            
            elif self.secRe.match(cond.attrib['name']):
                for paramV in cond.findall('paramVector'):
                    if paramV.attrib['name'] == 'dRotXYZ':
                        dRotXYZ = paramV.text.strip('*mrad').split('*mrad')
                        if self.whichRich == 2:
                            mirrNumber = cond.attrib['name'].replace('Rich2', '')
                        else:
                            mirrNumber = cond.attrib['name']
                        mirrNumber = mirrNumber.strip('SecMirror_Align')
                        secTiltY[int(float(mirrNumber))] = float(dRotXYZ[1])
                        secTiltZ[int(float(mirrNumber))] = float(dRotXYZ[2])
                        
        return [priTiltY, priTiltZ, secTiltY, secTiltZ]
    
    def getAbsMax(self):
        biggestTilt = [0,0,0,0]
        for pri in range(0,self.maxpri + 1):
            if abs(self.priY[pri]) > biggestTilt[0]:
                biggestTilt[0] = abs(self.priY[pri])
            if abs(self.priZ[pri]) > biggestTilt[1]:
                biggestTilt[1] = abs(self.priZ[pri])
        for sec in range(0,self.maxsec + 1):    
            if abs(self.secY[sec]) > biggestTilt[2]:
                biggestTilt[2] = abs(self.secY[sec])
            if abs(self.secZ[sec]) > biggestTilt[3]:
                biggestTilt[3] = abs(self.secZ[sec])
        return biggestTilt