
#include "dic.hxx"
#include <string>

/*
  Class DimInfoHistos
  A DimInfo that retrieve a histogram published by Gaucho
  and fill a root histogram
  
  Author: J. Helder Lopes, 27/07/2006
  
*/

class DimInfoTitle : public DimInfo 
{
  
public : 
  
  DimInfoTitle(std::string commentSvcname, int rtime);
  DimInfoTitle(std::string commentSvcname);
  virtual ~DimInfoTitle();
  char* getTitle();
  
private:
  
  // Overloaded method infoHandler, called whenever commands arrive 
  void infoHandler() override;

  // refresh interval
  int m_rtime{0};
  
  // ROOT histogram
  
  char* m_data = nullptr;
  bool m_hasData{false}; // true after histo has been filled first time
  
  // private methods to fill the histograms
  void setTitleData();
  
};
