#ifndef RICHMON_SLEEPER_H
#define RICHMON_SLEEPER_H


// from Gaudi
#include "GaudiAlg/GaudiAlgorithm.h"
#include "GaudiKernel/AlgFactory.h"

namespace Rich
{
  namespace Mon
  {

    class Sleeper final : public GaudiAlgorithm 
    {

    private:

      static const int OSCISCALE= 10;
    
    public: // methods
    
      // Standard constructor
      Sleeper( const std::string& name, ISvcLocator* pSvcLocator );

      virtual StatusCode initialize() override;    // Algorithm initialization
      virtual StatusCode execute   () override;    // Algorithm execution
      virtual StatusCode finalize  () override;    // Algorithm finalization

    private:

      std::string m_myname;
      int m_val1{0};
      int m_val2{0};

    };
  }
}

#endif
